package org.apache.bcel.generic;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Hashtable;
import java.util.Stack;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.MethodGen;

final class BranchStack {
  private final Stack<MethodGen.BranchTarget> branchTargets = new Stack<>();
  
  private final Hashtable<InstructionHandle, MethodGen.BranchTarget> visitedTargets = new Hashtable<>();
  
  public MethodGen.BranchTarget pop() {
    if (!this.branchTargets.empty())
      return this.branchTargets.pop(); 
    return null;
  }
  
  public void push(InstructionHandle target, int stackDepth) {
    if (visited(target))
      return; 
    this.branchTargets.push(visit(target, stackDepth));
  }
  
  private MethodGen.BranchTarget visit(InstructionHandle target, int stackDepth) {
    MethodGen.BranchTarget bt = new MethodGen.BranchTarget(target, stackDepth);
    this.visitedTargets.put(target, bt);
    return bt;
  }
  
  private boolean visited(InstructionHandle target) {
    return (this.visitedTargets.get(target) != null);
  }
}
